<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { ref } from 'vue';
import Modal from '@/components/general/Modal.vue';

const isModalOpen = ref(false);
const showModal = (value:boolean)=>{
    isModalOpen.value = true;
}

const checkCookies = ()=>{
    if (navigator.cookieEnabled) return true;
    // Create cookie
    document.cookie = "cookietest=1";
    let ret = document.cookie.indexOf("cookietest=") !== -1;
    // Delete cookie
    document.cookie = "cookietest=1; expires=Thu, 01-Jan-1970 00:00:01 GMT";
    return ret;
}

const checkLocalStorage = ()=>{
    let test = 'test';
    try {
        localStorage.setItem(test, test);
        localStorage.removeItem(test);
        return true;
    } catch(e) {
        return false;
    }
}

const checkCookiesAndStorage = ()=>{
    if(!checkCookies() && !checkLocalStorage()){
        showModal(true);
    }
}

checkCookiesAndStorage();

</script>
<template>
    <slot></slot>
    <Modal :header="$t('general.errors.cookies.notSet')" :text="$t('general.errors.cookies.noUse')" :labelSubmit="$t('general.buttons.ok')" v-if="isModalOpen" @submit="showModal(false)"/>
</template>